
	/* generates price indices */

		ren VPV price_var /* price variation in main mkt*/
		replace price_var=VPV1 if price_var==. & VPV1!=. /* uses price variation in main market if weghted price variation in all markets is missing */
	
		replace price_var=(L.price_var+F.price_var)/2 if price_var==. & L.price_var!=. & F.price_var!=.
		/* USE INDUSTRY DEFLATOR TO BUILD THE SERIES WHEN INDIVIDUAL PRICES ARE NOT REPORTED */
		replace price_var=100*dVA_def if price_var==. & (L.price_var!=. | F.price_var!=.)
		
		gen p_index=1 if price_var==. & F.price_var!=.
		replace p_index=(1+price_var/100) if L.p_index!=1 & price_var!=. & YEAR==1990
		replace p_index=(1+price_var/100) if L.price_var==. & price_var!=. & p_index==. & L.p_index!=1 & YEAR>1990
		by ORDINAL: gen test=1 if p_index!=.
		by ORDINAL: egen stest=sum(test)
		replace p_index=L.p_index*(1+price_var/100) if YEAR>1990 & L.p_index!=.
		/* REPLACES THE INDEX WITH INDUSTRY DEFLATOR FOR THE CASES ALL VALUES ARE MISSING*/
		replace p_index=VA_def if stest==0
		drop test stest
		
	/* GENERATE TECHNOLOGICAL VARIABLES */
		
		gen RD_Y=GTID/VENTAS
		drop if ORDINAL==1632 /* DROP FIRM WITH EXCESSIVELY LARGE RD TO SALES RATIOS */
		gen rd=0 if RD_Y==0
		replace rd=1 if RD_Y>0 & RD_Y!=.
		/* number of patents and patent dummies */

			gen pat_dum=0 if PATESP==0 | PATEXT==0
			replace pat_dum=1 if PATESP>0 & PATESP!=.
			replace pat_dum=1 if PATEXT>0 & PATEXT!=.
			gen pat_cat=0 if pat_dum==0
			replace pat_cat=1 if PATESP==0

		ren NIP N_pdi
		gen pdi_dum=0 if N_pdi==0
		replace pdi_dum=1 if N_pdi>0 & N_pdi!=.
		gen pci=2-IPR
		gen proc_innov_machine=0 if TIPSO==1
		replace proc_innov_machine=1 if TIPSO==2 | TIPSO==4
		gen proc_innov_methods=0 if TIPSO==1
		replace proc_innov_methods=1 if TIPSO==3 | TIPSO==4
		gen innov_dum =0
		replace innov_dum=1 if pci==1 | pdi==1
		gen tech_exp=0 if EXPTEC==0
		replace tech_exp=1 if EXPTEC>0 & EXPTEC!=.
		gen tech_imp=0 if IMPTEC==0
		replace tech_imp=1 if IMPTEC>0 & IMPTEC!=.
		
		
	/* generates capital stock */
	
		gen K_tot_gross=(COVA+RIMVA+TEVA)/GFCF_def
	
		gen I= CIM/GFCF_def
		gen I_min=VIM/GFCF_def
	
		so ORDINAL YEAR
		qui by ORDINAL:ge first0=1 if L.YEAR==. & YEAR>1990
		qui by ORDINAL:replace first0=1 if L.YEAR==1990 
	/*	qui by ORDINAL: gen Kac=sum(K_tot_gross) if K_tot_gross!=.
		qui by ORDINAL:ge first0=1 if L.Kac==. & Kac!=. */
	
		ge k_init=K_tot_gross if first0==1
		egen k0=min(k_init),by(ORDINAL)
		ge K_adj=k0 if first0==1
		qui by ORDINAL: replace K_adj = (1-0.08)*L.K_adj + I - I_min if first0~=1
		replace K_adj=0 if K_adj<0
	
		ren K_adj K_adj1
		
		gen K_land=TEVA/GFCF_def
		gen K_build=COVA/GFCF_def
		gen K_otherim=RIMVA/GFCF_def
	
		gen I_land=CIM*PIT/(100*GFCF_def)
		gen I_build=CIM*PIEO/(100*GFCF_def)
		gen I_otherim=CIM/GFCF_def-I_land-I_build 
		
	
		ge k_init_land=K_land if first0==1
		egen k0_land=min(k_init_land),by(ORDINAL)
		ge K_land_adj=k0_land if first0==1
		qui by ORDINAL: replace K_land_adj = L.K_land_adj + I_land if first0~=1
		replace K_land_adj=0 if K_land_adj<0
	
		ge k_init_build=K_build if first0==1
		egen k0_build=min(k_init_build),by(ORDINAL)
		ge K_build_adj=k0_build if first0==1
		qui by ORDINAL: replace K_build_adj = (1-0.025)*L.K_build_adj + I_build if first0~=1
		replace K_build_adj=0 if K_build_adj<0
	
	
		ge k_init_otherim=K_otherim if first0==1
		egen k0_otherim=min(k_init_otherim),by(ORDINAL)
		ge K_otherim_adj=k0_otherim if first0==1
		qui by ORDINAL: replace K_otherim_adj = (1-0.15)*L.K_otherim_adj + I_otherim if first0~=1
		replace K_otherim_adj=0 if K_otherim_adj<0 
	
		gen K_adj=K_land_adj+K_build_adj+K_otherim_adj
	
		drop first0 k_init* k0*


		
		
		
ren NCM1N N_comp /* Number of competitors with market power in main market: categorical variable: 1:<10, 2:11-25, 3:>25, 4:many*/
ren CI1N mkt_share /* Market share in main market */
	
quietly tabulate YEAR, generate(YEAR_)
quietly tabulate NACECLIO, generate(NACE_)
quietly tabulate ORDINAL, generate(ORDINAL_)
gen k_adj=ln(K_adj)

gen VE=-VESP*VENTAS/(100+VESP)
gen Y=(VENTAS+VE)
gen y=ln(Y)
gen q=ln(Y/p_index)
gen p=ln(p_index)
gen inv=ln(I)

gen N_comp1=0 if N_comp!=.
gen N_comp2=0 if N_comp!=.
gen N_comp3=0 if N_comp!=.
gen N_comp4=0 if N_comp!=.

replace N_comp1=1 if N_comp==1
replace N_comp2=1 if N_comp==2
replace N_comp3=1 if N_comp==3
replace N_comp4=1 if N_comp==4

/*  GENERATES DUMMY FOR ALL ZEROS AND ALL ONES IN BOTH PdI and PcI */

gen ones_all=.
replace ones_all=1
gen ones_proc=0 if ones_all==1
replace ones_proc=1 if F.pci==1
gen ones_prod=0 if ones_all==1
replace ones_prod=1 if F.pdi==1

by ORDINAL: egen nip_proc=sum(ones_proc)
by ORDINAL: egen nip_prod=sum(ones_prod)
by ORDINAL: egen nip=sum(ones_all)

	/* generates materials price indices */

		ren VPMP materialsprice_var /* price variation in main mkt*/
		replace materialsprice_var=VPV1 if materialsprice_var==. & VPV1!=. /* uses price variation in main market if weghted price variation in all markets is missing */
	
		replace materialsprice_var=(L.materialsprice_var+F.materialsprice_var)/2 if materialsprice_var==. & L.materialsprice_var!=. & F.materialsprice_var!=.
		/* USE INDUSTRY DEFLATOR TO BUILD THE SERIES WHEN INDIVIDUAL PRICES ARE NOT REPORTED */
		replace materialsprice_var=100*dVA_def if materialsprice_var==. & (L.materialsprice_var!=. | F.materialsprice_var!=.)
		
		gen materialsp_index=1 if materialsprice_var==. & F.materialsprice_var!=.
		replace materialsp_index=(1+materialsprice_var/100) if L.materialsp_index!=1 & materialsprice_var!=. & YEAR==1990
		replace materialsp_index=(1+materialsprice_var/100) if L.materialsprice_var==. & materialsprice_var!=. & materialsp_index==. & L.materialsp_index!=1 & YEAR>1990
		by ORDINAL: gen test=1 if materialsp_index!=.
		by ORDINAL: egen stest=sum(test)
		replace materialsp_index=L.materialsp_index*(1+materialsprice_var/100) if YEAR>1990 & L.materialsp_index!=.
		/* REPLACES THE INDEX WITH INDUSTRY DEFLATOR FOR THE CASES ALL VALUES ARE MISSING*/
		replace materialsp_index=VA_def if stest==0
		drop test stest

		ren VPS servicesprice_var /* price variation in main mkt*/
		replace servicesprice_var=VPV1 if servicesprice_var==. & VPV1!=. /* uses price variation in main market if weghted price variation in all markets is missing */
	
		replace servicesprice_var=(L.servicesprice_var+F.servicesprice_var)/2 if servicesprice_var==. & L.servicesprice_var!=. & F.servicesprice_var!=.
		/* USE INDUSTRY DEFLATOR TO BUILD THE SERIES WHEN INDIVIDUAL PRICES ARE NOT REPORTED */
		replace servicesprice_var=100*dVA_def if servicesprice_var==. & (L.servicesprice_var!=. | F.servicesprice_var!=.)
		
		gen servicesp_index=1 if servicesprice_var==. & F.servicesprice_var!=.
		replace servicesp_index=(1+servicesprice_var/100) if L.servicesp_index!=1 & servicesprice_var!=. & YEAR==1990
		replace servicesp_index=(1+servicesprice_var/100) if L.servicesprice_var==. & servicesprice_var!=. & servicesp_index==. & L.servicesp_index!=1 & YEAR>1990
		by ORDINAL: gen test=1 if servicesp_index!=.
		by ORDINAL: egen stest=sum(test)
		replace servicesp_index=L.servicesp_index*(1+servicesprice_var/100) if YEAR>1990 & L.servicesp_index!=.
		/* REPLACES THE INDEX WITH INDUSTRY DEFLATOR FOR THE CASES ALL VALUES ARE MISSING*/
		replace servicesp_index=VA_def if stest==0
		drop test stest

drop if ORDINAL==2675 & YEAR<2001
gen L=PERFTC+PERFTP+PERE+PERDG if YEAR==1990
replace L=PERFTC+PERFTP+PERE+PAFDG if YEAR>1990

gen L_temp=PERE
gen L_hours=HNOR+HEXN
gen L_hours_ext=HEXN
gen L_hours_notworked=HNOTN

gen M=COMP
gen mdef=ln(M/materialsp_index)
gen W=CP
gen m_w=ln(M/W)
gen qr=ln(VENTAS/p_index)
gen qp=ln((VENTAS+VE)/p_index)
gen yr=ln(VENTAS)	
gen yp=ln(VENTAS+VE)
gen kg=ln(K_tot_gross)
gen l=ln(L)
gen w=ln(W)
gen m=ln(M)
gen kadj=ln(K_adj)
gen fse=ln(SEA)
gen fsedef=fse-ln(servicesp_index)
gen wage=W/L
gen lwage=ln(wage)
gen lmaterialsp_index=ln(materialsp_index)

drop YEAR_*
quietly tabulate YEAR, generate(YEAR_)
gen lp_index=ln(p_index)

gen age=YEAR-FDY
gen lage=ln(age)
/* Reorder the mkt change variable and the mkt_share change variable */

gen mkt_change=DM1N

/*	replace mkt_change=3 if mkt_change==1
	replace mkt_change=2 if mkt_change==0.5
	replace mkt_change=1 if mkt_change==0*/

gen mkt_share_change=4-ECM1

/*	replace mkt_share_change=1 if mkt_share_change==3
	replace mkt_share_change=3 if mkt_share_change==1*/
