%close all
for loop=1:4
% Number of firms
    N=500;
% Panel dimension
    T=20;
    drop=5; %drops the first "drop" periods
% number of simulations
    sdim=1000;
%Input prices
p_l=1; p_m=1;


% shock draws and values at t=1
sigma_e=0.35; % standard error of the demand shock

ed=normrnd(0,sigma_e,N,T);
gamma=normrnd(0.0,0.35,N,T);
k=zeros(N,T);
z=zeros(N,T);
a=zeros(N,T);
e=zeros(N,T);
q=zeros(N,T);
m=zeros(N,T);
l=zeros(N,T);
p=zeros(N,T);

k(:,1)=normrnd(10,1,N,1);
z(:,1)=zeros(N,1);
a(:,1)=normrnd(1,1,N,1);
e(:,1)=normrnd(2,1,N,1);

% Models parameters
    % demand elasticity
        sigma1=-2; sigma2=0; sigma3=0;
        phiz=0.25; delta=0.33;
        %phiz=0.75;
    % production function parameters

    if loop==1
        al=0.3; am=0.6; ak=0.1; all=0; alm=0; alk=0; amm=0; amk=0; akk=0; a0=10;
        p_ll=0;
    elseif loop==2
        al=0.65; am=1.2; ak=0.3; all=-0.025; alm=-0.01; alk=-0.005; amm=-0.05; amk=-0.01; akk=-0.01; a0=10;
        al=0.3; am=0.6; ak=0.1; all=-0.025; alm=0.025; alk=0.00; amm=-0.025; amk=-0.00; akk=0; a0=10;
        p_ll=0;
    elseif loop==3
        al=0.3; am=0.6; ak=0.1; all=0; alm=0; alk=0; amm=0; amk=0; akk=0; a0=10;
        p_ll=20;
    elseif loop==4
        al=0.3; am=0.6; ak=0.1; all=0; alm=0; alk=0; amm=0; amk=0; akk=0; a0=10;
        sigma1=-2;sigma2=0.005;sigma3=-0.00025;
        sigma1=-3;sigma2=-0.005;sigma3=0.00025;
        sigma1=-20;sigma2=-0.05;sigma3=+0.005;
    end
    
    % Dynamics
     % Productivity
     g1a=0.95;
     % demand
     g1e=0.95;

%     k,l,m,q,p,z
    ed_draws=normrnd(0,sigma_e,N,T,sdim);
	optionsfmin = optimset('GradObj','on','TolFun',1.0000e-6,'TolX',1.0000e-8,'MaxFunEvals',1000,'display','off');

    tic
     for t=2:T
         k(:,t)=k(:,t-1)+normrnd(0,0.15,N,1);
         a(:,t)=g1a*a(:,t-1)+gamma(:,t);
         e(:,t)=g1e*e(:,t-1)+ed(:,t);
             for i=1:N
                 
                fun=@(x)optimal_l(x,i,t,a,a0,al,all,alm,alk,am,amm,amk,ak,akk,phiz,sigma1,sigma2,sigma3,p_l,p_ll,p_m,l,k,z,e,ed_draws,g1e);
                if t==2
                    l(i,t-1)=0.1; m(i,t-1)=0.1;
                end

                [aaa bbb] = fminsearch(fun,[l(i,t-1) m(i,t-1)],optionsfmin);
                l(i,t)=aaa(1);

                fun=@(x)optimal_m(x,i,t,a,a0,al,all,alm,alk,am,amm,amk,ak,akk,phiz,sigma1,sigma2,sigma3,p_l,p_ll,p_m,l,k,z,e);

                [aaa bbb]= fminsearch(fun,[aaa(2)],optionsfmin);
                m(i,t)=aaa(1);

             end
             q(:,t)=a0+(a(:,t)+al*l(:,t)+all*l(:,t).*l(:,t)+alm*l(:,t).*m(:,t)+am*m(:,t)+amm*m(:,t).*m(:,t)+amk*m(:,t).*k(:,t)+ak*k(:,t)+akk*k(:,t).*k(:,t));
             p(:,t)=min((1/sigma1)*(q(:,t)+sigma2*q(:,t).^2+sigma3*q(:,t).^3-ed(:,t)-phiz*z(:,t-1)),250); % minimum to prevent p=Inf

             z(:,t)=log(max((1-delta)*exp(z(:,t-1))+exp(p(:,t)).*exp(q(:,t)),1.0e-12));
             m_lag=m(:,t-1); l_lag=l(:,t-1);
     end
     toc
	display('Note variales in logs - use exp(l) and exp(m) to calculate ratio')
    beta=regress(reshape([m(:,drop:T)-l(:,drop:T)],[N*(T-drop+1) 1]),[ones(N*(T-drop+1),1) reshape([m(:,drop-1:T-1)-l(:,drop-1:T-1)],[N*(T-drop+1) 1])])
    ed_hat=(reshape([m(:,drop:T)-l(:,drop:T)],[N*(T-drop+1) 1])-beta(1)*ones(N*(T-drop+1),1)-beta(2)*reshape([m(:,drop-1:T-1)-l(:,drop-1:T-1)],[N*(T-drop+1) 1]));

    subplot(2,2,loop)
    scatter(reshape([ed(:,drop:T)],[N*(T-drop+1) 1]),ed_hat,'.','MarkerEdgeColor','k','MarkerFaceColor','k')
    y3 = max(ed_hat);
    x3 = min(min(ed(:,drop:T)));
    corr_ed=corr(ed_hat, reshape([ed(:,drop:T)],[N*(T-drop+1) 1]))
    strmin = ['Corr = ',num2str(100*corr_ed,4)];
    text(x3,y3,strmin,'HorizontalAlignment','left')
    ylabel({'Estimated demand shock', '(via input ratio)'},'fontsize',9)
    xlabel('True demand shock','fontsize',9)
    if loop==1
        title('(i) Baseline case','fontweight','bold','fontsize',11);
%         title('N=100, T=5','fontweight','bold','fontsize',11);
    elseif loop==2
        title('(ii) Translog production function','fontweight','bold','fontsize',11);
    elseif loop==3
        title('(iii) Labour quadratic adj. costs','fontweight','bold','fontsize',11);
    elseif loop==4
        title('(iv) Cubic demand','fontweight','bold','fontsize',11);
        stop
        savefig('Montecarlo_scatterb');
        close all
        h=openfig('Montecarlo_scatterb.fig');
        set(h,'Units','Inches');
        pos = get(h,'Position');
        set(h,'PaperPositionMode','Auto','PaperUnits','Inches','PaperSize',[pos(3), pos(4)])
        print(h,'Montecarlo_scatter','-dpdf','-r0');
        print(h,'Montecarlo_scatter','-djpeg','-r0');
    end
    hold on 
end